All patches and comments are welcome. Please squash your changes to logical
commits before using git-format-patch and git-send-email to
patches@git.madduck.net.
If you'd read over the Git project's submission guidelines and adhered to them,
I'd be especially grateful.
3 # This program is licensed under the GNU GPL version 2 or later.
4 # (c) Richard "RichiH" Hartmann <richih@debian.org>, 2011-2014
5 # For details, see LICENSE. To submit patches, you have to agree to
6 # license your code under the GNU GPL version 2 or later.
8 # While the following is not legally binding, the author would like to
9 # explain the choice of GPLv2+ over GPLv3+.
10 # The author prefers GPLv3+ over GPLv2+ but feels it's better to maintain
11 # full compatibility's with Git. In case Git ever changes its licensing terms,
12 # which is admittedly extremely unlikely to the point of being impossible,
13 # this software will most likely follow suit.
15 # This should always be the first line of code to facilitate debugging
16 [ -n "$VCSH_DEBUG" ] && set -vx
19 # If '.git-HEAD' is appended to the version, you are seeing an unreleased
20 # version of vcsh; the master branch is supposed to be clean at all times
21 # so you can most likely just use it nonetheless
26 echo "$SELF: fatal: $1" >&2
31 # We need to run getops as soon as possible so we catch -d and other
32 # options that will modify our behaviour.
33 # Commands are handled at the end of this script.
34 while getopts "c:dv" flag; do
35 if [ x"$1" = x'-d' ] || [ x"$1" = x'--debug' ]; then
40 elif [ x"$1" = x'-v' ]; then
42 echo "verbose mode on"
44 elif [ x"$1" = x'-c' ]; then
45 VCSH_OPTION_CONFIG=$OPTARG
51 # Source file even if it's in $PWD and does not have any slashes in it
59 # Read configuration and set defaults if anything's not set
60 [ -n "$VCSH_DEBUG" ] && set -vx
61 : ${XDG_CONFIG_HOME:="$HOME/.config"}
63 # Read configuration files if there are any
64 [ -r "/etc/vcsh/config" ] && . "/etc/vcsh/config"
65 [ -r "$XDG_CONFIG_HOME/vcsh/config" ] && . "$XDG_CONFIG_HOME/vcsh/config"
66 if [ -n "$VCSH_OPTION_CONFIG" ]; then
67 # Source $VCSH_OPTION_CONFIG if it can be read and is in $PWD of $PATH
68 if [ -r "$VCSH_OPTION_CONFIG" ]; then
69 source_all "$VCSH_OPTION_CONFIG"
71 fatal "Can not read configuration file '$VCSH_OPTION_CONFIG'" 1
74 [ -n "$VCSH_DEBUG" ] && set -vx
77 : ${VCSH_REPO_D:="$XDG_CONFIG_HOME/vcsh/repo.d"}
78 : ${VCSH_HOOK_D:="$XDG_CONFIG_HOME/vcsh/hooks-enabled"}
79 : ${VCSH_BASE:="$HOME"}
80 : ${VCSH_GITIGNORE:=exact}
81 : ${VCSH_GITATTRIBUTES:=none}
82 : ${VCSH_WORKTREE:=absolute}
84 if [ ! "x$VCSH_GITIGNORE" = 'xexact' ] && [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && [ ! "x$VCSH_GITIGNORE" = 'xrecursive' ]; then
85 fatal "'\$VCSH_GITIGNORE' must equal 'exact', 'none', or 'recursive'" 1
88 if [ ! "x$VCSH_WORKTREE" = 'xabsolute' ] && [ ! "x$VCSH_WORKTREE" = 'xrelative' ]; then
89 fatal "'\$VCSH_WORKTREE' must equal 'absolute', or 'relative'" 1
94 echo "usage: $SELF <options> <command>
99 -v Enable verbose mode
103 [<repo>] Clone from an existing repository
104 commit Commit in all repositories
105 delete <repo> Delete an existing repository
106 enter <repo> Enter repository; spawn new instance of \$SHELL
107 help Display this help text
108 init <repo> Initialize a new repository
109 list List all repositories
110 list-tracked List all files tracked by vcsh
112 <repo> List files tracked by a repository
113 pull Pull from all vcsh remotes
114 push Push to vcsh remotes
116 <newname> Rename repository
118 <command> Use this repository
119 status [<repo>] Show statuses of all/one vcsh repositories
120 upgrade <repo> Upgrade repository to currently recommended settings
121 version Print version information
122 which <substring> Find substring in name of any tracked file
124 <repo> Write .gitignore.d/<repo> via git ls-files
126 <repo> <git command> Shortcut to run git commands directly
127 <repo> Shortcut to enter repository" >&2
131 [ -n "$VCSH_DEBUG" ] && echo "$SELF: debug: $@"
135 if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $@"; fi
139 echo "$SELF: error: $1" >&2
143 echo "$SELF: info: $1"
149 git remote add origin "$GIT_REMOTE"
150 git config branch.master.remote origin
151 git config branch.master.merge refs/heads/master
152 VCSH_CLONE_ERROR=$(git ls-remote origin master 2>&1)
153 if [ -n "$VCSH_CLONE_ERROR" ]; then
155 fatal "$VCSH_CLONE_ERROR" 1
159 git ls-tree -r --name-only origin/master | (while read object; do
161 error "'$object' exists." &&
164 [ x"$VCSH_CONFLICT" = x'1' ]) &&
165 fatal "will stop after fetching and not try to merge!
166 Once this situation has been resolved, run 'vcsh $VCSH_REPO_NAME pull' to finish cloning." 17
167 git merge origin/master
171 hook post-clone-retired
176 for VCSH_REPO_NAME in $(list); do
177 echo "$VCSH_REPO_NAME: "
178 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
180 git commit --untracked-files=no --quiet
181 VCSH_COMMAND_RETURN_CODE=$?
188 cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
190 info "This operation WILL DESTROY DATA!"
191 files=$(git ls-files)
192 echo "These files will be deleted:
196 AGAIN, THIS WILL DELETE YOUR DATA!
197 To continue, type 'Yes, do as I say'"
199 [ "x$answer" = 'xYes, do as I say' ] || exit 16
200 for file in $files; do
201 rm -f $file || info "could not delete '$file', continuing with deletion"
203 rm -rf "$GIT_DIR" || error "could not delete '$GIT_DIR'"
214 [ -d "$GIT_DIR" ] || fatal "no repository found for '$VCSH_REPO_NAME'" 12
218 for hook in "$VCSH_HOOK_D/$1"* "$VCSH_HOOK_D/$VCSH_REPO_NAME.$1"*; do
219 [ -x "$hook" ] || continue
220 verbose "executing '$hook'"
227 [ ! -e "$GIT_DIR" ] || fatal "'$GIT_DIR' exists" 10
228 mkdir -p "$VCSH_BASE" || fatal "could not create '$VCSH_BASE'" 50
229 cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
230 git init --shared=0600
236 for repo in "$VCSH_REPO_D"/*.git; do
237 [ -d "$repo" ] && [ -r "$repo" ] && echo "$(basename "$repo" .git)"
242 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
247 for VCSH_REPO_NAME in $(list); do
249 done | sed "s,^,$(printf '%s\n' "$VCSH_BASE/" | \
250 sed 's/[,\&]/\\&/g')," | sort -u
255 git ls-files | sed "s,^,$(printf '%s\n' "$VCSH_BASE/" | \
256 sed 's/[,\&]/\\&/g')," | sort -u
261 for VCSH_REPO_NAME in $(list); do
262 printf '%s: ' "$VCSH_REPO_NAME"
263 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
266 VCSH_COMMAND_RETURN_CODE=$?
274 for VCSH_REPO_NAME in $(list); do
275 printf '%s: ' "$VCSH_REPO_NAME"
276 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
279 VCSH_COMMAND_RETURN_CODE=$?
291 [ -d "$GIT_DIR_NEW" ] && fatal "'$GIT_DIR_NEW' exists" 54
292 mv -f "$GIT_DIR" "$GIT_DIR_NEW" || fatal "Could not mv '$GIT_DIR' '$GIT_DIR_NEW'" 52
294 # Now that the repository has been renamed, we need to fix up its configuration
295 # Overwrite old name..
297 VCSH_REPO_NAME=$VCSH_REPO_NAME_NEW
298 # ..and clobber all old configuration
306 VCSH_COMMAND_RETURN_CODE=$?
311 if [ -n "$VCSH_REPO_NAME" ]; then
312 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
314 git status --short --untracked-files='no'
315 VCSH_COMMAND_RETURN_CODE=$?
317 for VCSH_REPO_NAME in $(list); do
318 echo "$VCSH_REPO_NAME:"
319 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
321 git status --short --untracked-files='no'
322 VCSH_COMMAND_RETURN_CODE=$?
330 # fake-bare repositories are not bare, actually. Set this to false
331 # because otherwise Git complains "fatal: core.bare and core.worktree
333 git config core.bare false
334 # core.worktree may be absolute or relative to $GIT_DIR, depending on
336 if [ ! "x$VCSH_WORKTREE" = 'xabsolute' ]; then
337 git config core.worktree "$(cd "$GIT_DIR" && GIT_WORK_TREE=$VCSH_BASE git rev-parse --show-cdup)"
338 elif [ ! "x$VCSH_WORKTREE" = 'xrelative' ]; then
339 git config core.worktree "$VCSH_BASE"
341 [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
342 [ ! "x$VCSH_GITATTRIBUTES" = 'xnone' ] && git config core.attributesfile ".gitattributes.d/$VCSH_REPO_NAME"
343 git config vcsh.vcsh 'true'
345 [ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ] && git add -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME"
346 [ -e "$VCSH_BASE/.gitattributes.d/$VCSH_REPO_NAME" ] && git add -f "$VCSH_BASE/.gitattributes.d/$VCSH_REPO_NAME"
352 VCSH_DIRECTORY=$VCSH_REPO_NAME; export VCSH_DIRECTORY
356 [ -e "$VCSH_COMMAND_PARAMETER" ] || fatal "'$VCSH_COMMAND_PARAMETER' does not exist" 1
357 for VCSH_REPO_NAME in $(list); do
358 for VCSH_FILE in $(get_files); do
359 echo "$VCSH_FILE" | grep -q "$VCSH_COMMAND_PARAMETER" && echo "$VCSH_REPO_NAME: $VCSH_FILE"
365 # Don't do anything if the user does not want to write gitignore
366 if [ "x$VCSH_GITIGNORE" = 'xnone' ]; then
367 info "Not writing gitignore as '\$VCSH_GITIGNORE' is set to 'none'"
372 cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
375 gitignores=$(for file in $(git ls-files); do
377 echo "$file"; new=${file%/*}
378 [ x"$file" = x"$new" ] && break
383 # Contrary to GNU mktemp, mktemp on BSD/OSX requires a template for temp files
384 # Using a template makes GNU mktemp default to $PWD and not #TMPDIR for tempfile location
385 # To make every OS happy, set full path explicitly
386 tempfile=$(mktemp "${TMPDIR:-/tmp}/tmp.XXXXXXXXXX") || fatal "could not create tempfile: '${tempfile}'" 51
388 echo '*' > "$tempfile" || fatal "could not write to '$tempfile'" 57
389 for gitignore in $gitignores; do
390 echo "$gitignore" | sed 's@^@!/@' >> "$tempfile" || fatal "could not write to '$tempfile'" 57
391 if [ "x$VCSH_GITIGNORE" = 'xrecursive' ] && [ -d "$gitignore" ]; then
392 { echo "$gitignore/*" | sed 's@^@!/@' >> "$tempfile" || fatal "could not write to '$tempfile'" 57; }
396 if diff -N "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" > /dev/null; then
397 rm -f "$tempfile" || error "could not delete '$tempfile'"
400 if [ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ]; then
401 info "'$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME' differs from new data, moving it to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak'"
402 mv -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak" ||
403 fatal "could not move '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak'" 53
405 mv -f "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ||
406 fatal "could not move '$tempfile' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME'" 53
411 if [ ! "x$VCSH_GITIGNORE" = 'xexact' ] && [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && [ ! "x$VCSH_GITIGNORE" = 'xrecursive' ]; then
412 fatal "'\$VCSH_GITIGNORE' must equal 'exact', 'none', or 'recursive'" 1
415 VCSH_COMMAND=$1; export VCSH_COMMAND
417 case $VCSH_COMMAND in
418 clon|clo|cl) VCSH_COMMAND=clone;;
419 commi|comm|com|co) VCSH_COMMAND=commit;;
420 delet|dele|del|de) VCSH_COMMAND=delete;;
421 ente|ent|en) VCSH_COMMAND=enter;;
422 hel|he) VCSH_COMMAND=help;;
423 ini|in) VCSH_COMMAND=init;;
424 pul) VCSH_COMMAND=pull;;
425 pus) VCSH_COMMAND=push;;
426 renam|rena|ren|re) VCSH_COMMAND=rename;;
427 ru) VCSH_COMMAND=run;;
428 statu|stat|sta|st) VCSH_COMMAND=status;;
429 upgrad|upgra|upgr|up) VCSH_COMMAND=upgrade;;
430 versio|versi|vers|ver|ve) VCSH_COMMAND=version;;
431 which|whi|wh) VCSH_COMMAND=which;;
432 write|writ|wri|wr) VCSH_COMMAND=write-gitignore;;
435 if [ x"$VCSH_COMMAND" = x'clone' ]; then
436 [ -z "$2" ] && fatal "$VCSH_COMMAND: please specify a remote" 1
438 [ -n "$3" ] && VCSH_REPO_NAME=$3 || VCSH_REPO_NAME=$(basename "${GIT_REMOTE#*:}" .git)
439 [ -z "$VCSH_REPO_NAME" ] && fatal "$VCSH_COMMAND: could not determine repository name" 1
440 export VCSH_REPO_NAME
441 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
442 elif [ "$VCSH_COMMAND" = 'version' ]; then
443 echo "$SELF $VERSION"
446 elif [ x"$VCSH_COMMAND" = x'which' ]; then
447 [ -z "$2" ] && fatal "$VCSH_COMMAND: please specify a filename" 1
448 [ -n "$3" ] && fatal "$VCSH_COMMAND: too many parameters" 1
449 VCSH_COMMAND_PARAMETER=$2; export VCSH_COMMAND_PARAMETER
450 elif [ x"$VCSH_COMMAND" = x'delete' ] ||
451 [ x"$VCSH_COMMAND" = x'enter' ] ||
452 [ x"$VCSH_COMMAND" = x'init' ] ||
453 [ x"$VCSH_COMMAND" = x'list-tracked-by' ] ||
454 [ x"$VCSH_COMMAND" = x'rename' ] ||
455 [ x"$VCSH_COMMAND" = x'run' ] ||
456 [ x"$VCSH_COMMAND" = x'upgrade' ] ||
457 [ x"$VCSH_COMMAND" = x'write-gitignore' ]; then
458 [ -z "$2" ] && fatal "$VCSH_COMMAND: please specify repository to work on" 1
459 [ x"$VCSH_COMMAND" = x'rename' ] && [ -z "$3" ] && fatal "$VCSH_COMMAND: please specify a target name" 1
460 [ x"$VCSH_COMMAND" = x'run' ] && [ -z "$3" ] && fatal "$VCSH_COMMAND: please specify a command" 1
461 VCSH_REPO_NAME=$2; export VCSH_REPO_NAME
462 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
463 [ x"$VCSH_COMMAND" = x'rename' ] && { VCSH_REPO_NAME_NEW=$3; export VCSH_REPO_NAME_NEW;
464 GIT_DIR_NEW=$VCSH_REPO_D/$VCSH_REPO_NAME_NEW.git; export GIT_DIR_NEW; }
465 [ x"$VCSH_COMMAND" = x'run' ] && shift 2
466 elif [ x"$VCSH_COMMAND" = x'commit' ] ||
467 [ x"$VCSH_COMMAND" = x'list' ] ||
468 [ x"$VCSH_COMMAND" = x'list-tracked' ] ||
469 [ x"$VCSH_COMMAND" = x'pull' ] ||
470 [ x"$VCSH_COMMAND" = x'push' ]; then
472 elif [ x"$VCSH_COMMAND" = x'status' ]; then
473 VCSH_REPO_NAME=$2; export VCSH_REPO_NAME
474 elif [ -n "$2" ]; then
475 VCSH_COMMAND='run'; export VCSH_COMMAND
476 VCSH_REPO_NAME=$1; export VCSH_REPO_NAME
477 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
478 [ -d "$GIT_DIR" ] || { help; exit 1; }
481 elif [ -n "$VCSH_COMMAND" ]; then
482 VCSH_COMMAND='enter'; export VCSH_COMMAND
483 VCSH_REPO_NAME=$1; export VCSH_REPO_NAME
484 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
485 [ -d "$GIT_DIR" ] || { help; exit 1; }
487 # $1 is empty, or 'help'
491 # Did we receive a directory instead of a name?
492 # Mangle the input to fit normal operation.
493 if echo "$VCSH_REPO_NAME" | grep -q '/'; then
494 GIT_DIR=$VCSH_REPO_NAME; export GIT_DIR
495 VCSH_REPO_NAME=$(basename "$VCSH_REPO_NAME" .git); export VCSH_REPO_NAME
500 if [ ! -d "$check_directory" ]; then
501 if [ -e "$check_directory" ]; then
502 fatal "'$check_directory' exists but is not a directory" 13
504 verbose "attempting to create '$check_directory'"
505 mkdir -p "$check_directory" || fatal "could not create '$check_directory'" 50
510 check_dir "$VCSH_REPO_D"
511 [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && check_dir "$VCSH_BASE/.gitignore.d"
512 [ ! "x$VCSH_GITATTRIBUTES" = 'xnone' ] && check_dir "$VCSH_BASE/.gitattributes.d"
514 verbose "$VCSH_COMMAND begin"
515 VCSH_COMMAND=$(echo "$VCSH_COMMAND" | sed 's/-/_/g'); export VCSH_COMMAND
519 verbose "$VCSH_COMMAND end, exiting"
520 exit $VCSH_COMMAND_RETURN_CODE